<!DOCTYPE html>
<html lang="en">
<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body onload="onPageLoading()">
<div class="container">
  <p class="h3 text-left mt-5"> Order Detail !!! </p>
  <div class="form-group">
    <label>Order Code (mã đơn hàng):</label>
    <input type="text" class="form-control" id="input-ordercode">
  </div>
  <div class="form-group">
    <label>Cỡ Combo:</label>
    <select id="select-size" class="form-control">
      <option value="NOT_SELECT_COMBO">Chọn cỡ Combo (Combo Size)</option>
      <option value="S">Nhỏ</option>
      <option value="M">Vừa</option>
      <option value="L">Lớn</option>
    </select>
  </div>
  <div class="form-group">
    <label>Đường kính Pizza</label>
    <input type="text" class="form-control" id="input-duong-kinh">
  </div>
  <div class="form-group">
    <label>Sườn nướng (miếng)</label>
    <input type="text" class="form-control" id="input-suon-nuong">
  </div>
  <div class="form-group">
    <label>Đồ uống:</label>
    <select id="select-drink" class="form-control">
      <option value="NOT_SELECT_DRINK">Chọn đồ uống</option>
    </select>
  </div>
  <div class="form-group">
    <label>Số lượng nước</label>
    <input type="text" class="form-control" id="input-number">
  </div>
  <div class="form-group">
    <label>Voucher ID</label>
    <input type="text" class="form-control" id="input-voucherid">
  </div>
  <div class="form-group">
    <label>Loại pizza:</label>
    <select id="select-pizza" class="form-control">
      <option value="NOT_SELECT_PIZZA">Chọn loại Pizza</option>
      <option value="Seafood">Hải sản</option>
      <option value="Hawaii">Ha wai</option>
      <option value="Bacon">Thịt xông khói</option>
    </select>
  </div>
  <div class="form-group">
    <label>Salad</label>
    <input type="text" class="form-control" id="input-salad">
  </div>
  <div class="form-group">
    <label>Thành tiền</label>
    <input type="text" class="form-control" id="input-amount">
  </div>
  <div class="form-group">
    <label>Giảm giá</label>
    <input type="text" class="form-control" id="input-giam-gia">
  </div>
  <div class="form-group">
    <label>Họ và Tên</label>
    <input type="text" class="form-control" id="input-fullname">
  </div>
  <div class="form-group">
    <label>Email</label>
    <input type="text" class="form-control" id="input-email">
  </div>
  <div class="form-group">
    <label>Số điện thoại</label>
    <input type="text" class="form-control" id="input-phone">
  </div>
  <div class="form-group">
    <label>Địa chỉ</label>
    <input type="text" class="form-control" id="input-adress">
  </div>
  <div class="form-group">
    <label>Lời nhắn</label>
    <input type="text" class="form-control" id="input-message">
  </div>
  <div class="form-group">
    <label>Trạng thái đơn hàng</label>
    <input type="text" class="form-control" id="input-status">
  </div>
  <div class="form-group">
    <label>Ngày tạo đơn</label>
    <input type="text" class="form-control" id="input-create-order">
  </div>
  <div class="form-group">
    <label>Ngày cập nhật</label>
    <input type="text" class="form-control" id="input-update">
  </div>
  <div class="form-group">
    <button class="btn btn-group btn-success" id="btn-confirm">Confirm</button>
    <button class="btn btn-group btn-info" id="btn-cancel">Cancel</button>
  </div>
</div>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gId;
  var gOrderCode;
  const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
  const gREQUEST_STATUS_OK = 200;
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
 
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // hàm xử lý sự kiện tải trang
  function onPageLoading() {
    // Bước 1: đọc dữ liệu (Ko có)
    var vUrlString = window.location.href; // đường dẫn gọi đến trang
    console.log(vUrlString);
    // tạo đối tượng url để truy vấn tham số
    var vUrl = new URL(vUrlString);
    // truy vấn
    gId = vUrl.searchParams.get("id"); // set giá trị cho biến toàn cục gId
    gOrderCode = vUrl.searchParams.get("orderCode"); // set giá trị cho biến toàn cục gOrderCode ( để lấy thông tin chi tiết đơn hàng)
    // Bước 2: validate
    const vFROM_LIST_VIEW = "Task 26.10 Load data to List View (master- detail).html";
    if (gId == null || gId == "") {
      alert("Không có Id của đơn hàng");
      window.location.href = vFROM_LIST_VIEW;
    }
    else if (gOrderCode == null || gOrderCode == "") {
      alert("Không có orderCode");
      window.location.href = vFROM_LIST_VIEW;
    }
    console.log("Id: " + gId);
    console.log("orderCode: " + gOrderCode);
    // load dữ liệu vào select drink
    loadDataDrinkList();
    // Bước 3: gọi Api sever
    // gọi Api lấy thông tin đơn hàng
    var vXmlHttpOrder = new XMLHttpRequest();
    callApiOrderData(vXmlHttpOrder, gOrderCode);
    // Hàm xử lý thông tin Response Text trả về
    vXmlHttpOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                  // Bước 4: hiển thị dữ liệu lên form
                   showDataToForm(vXmlHttpOrder);
                }
            } 
  }
    
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // Hàm gọi Api sever
  function callApiOrderData(paramXMLHttpOrder, paramOrderCode) {
    const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    paramXMLHttpOrder.open("GET", vBASE_URL + "/" + paramOrderCode, true);
    paramXMLHttpOrder.send();
  }
  // Hàm hiển xử lý hiển thị dữ liệu lên form
  function showDataToForm(paramXMLHttp) {
    console.log(paramXMLHttp.responseText);
    // parsing dữ liệu thành object
    var vOrderDataObj = JSON.parse(paramXMLHttp.responseText);
    var vOrderCode = document.getElementById("input-ordercode");
    var vCombo = document.getElementById("select-size");
    var vDuongKinhPizza = document.getElementById("input-duong-kinh");
    var vDrink = document.getElementById("select-drink");
    var vSoLuongNuocUong = document.getElementById("input-number");
    var vPizzaType = document.getElementById("select-pizza");
    var vSalad = document.getElementById("input-salad");
    var vThanhTien= document.getElementById("input-amount");
    var vVoucherId = document.getElementById("input-voucherid");
    var vSuonNuong = document.getElementById("input-suon-nuong");
    var vGiamGia = document.getElementById("input-giam-gia");
    var vFullName = document.getElementById("input-fullname");
    var vEmail = document.getElementById("input-email");
    var vAdress = document.getElementById("input-adress");
    var vPhone = document.getElementById("input-phone");
    var vMessage = document.getElementById("input-message");
    var vTrangThaiDonHang = document.getElementById("input-status");
    var vNgayTaoDon = document.getElementById("input-create-order");
    var vNgayCapNhat = document.getElementById("input-update");

    vOrderCode.value = vOrderDataObj.orderCode;
    vCombo.value = vOrderDataObj.kichCo;
    vDuongKinhPizza.value = vOrderDataObj.duongKinh;
    vDrink.value = vOrderDataObj.idLoaiNuocUong;
    vSoLuongNuocUong.value = vOrderDataObj.soLuongNuoc;
    vPizzaType.value = vOrderDataObj.loaiPizza;
    vSalad.value = vOrderDataObj.salad;
    vThanhTien.value = vOrderDataObj.thanhTien;
    vVoucherId.value = vOrderDataObj.idVourcher;
    vSuonNuong.value = vOrderDataObj.suon;
    vGiamGia.value = vOrderDataObj.giamGia;
    vFullName.value = vOrderDataObj.hoTen;
    vEmail.value = vOrderDataObj.email;
    vAdress.value = vOrderDataObj.diaChi;
    vPhone.value = vOrderDataObj.soDienThoai;
    vMessage.value = vOrderDataObj.loiNhan;
    vTrangThaiDonHang.value = vOrderDataObj.trangThai;
    vNgayTaoDon.value = vOrderDataObj.ngayTao;
    vNgayCapNhat.value = vOrderDataObj.ngayCapNhat;


  }
  // Hàm load dữ liệu vào select drink
  function loadDataDrinkList() {
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/drinks";
        var vXhttp = new XMLHttpRequest();
        vXhttp.open("GET", vBASE_URL, true);
        vXhttp.send();
        vXhttp.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXhttp.responseText); //ghi response text ra console.log
                    handleLoadDataToSelectDrink(vXhttp);
                }
            };
  }
  // handle load data to select drink
  function handleLoadDataToSelectDrink(paramXhttp) {
    var vArrayListDrink = JSON.parse(paramXhttp.responseText);
    console.log("array list drink = " + vArrayListDrink.length);
    //  load data to drink select
    var vElementSelectDrink = document.getElementById("select-drink");
    for (var i =0; i < vArrayListDrink.length; i++) {
      var vDrinkOptionElement = document.createElement("option");
      vDrinkOptionElement.value = vArrayListDrink[i].maNuocUong;
      vDrinkOptionElement.text = vArrayListDrink[i].tenNuocUong;
      vElementSelectDrink.appendChild(vDrinkOptionElement);
    }

  }

</script>
</body>
</html>